# MacOS-specific toolchain template file for gcc running on x86_64 Darwin
set(CMAKE_SYSTEM_NAME Darwin)
set(CMAKE_SYSTEM_PROCESSOR x86_64)
set(CMAKE_SYSTEM_VERSION 14.5)

# Extract out DARWIN_MAJOR_VERSION and DARWIN_MINOR_VERSION
string(REGEX REPLACE "^([0-9]+)\\.([0-9]+).*$" "\\1" DARWIN_MAJOR_VERSION "${CMAKE_SYSTEM_VERSION}")
string(REGEX REPLACE "^([0-9]+)\\.([0-9]+).*$" "\\2" DARWIN_MINOR_VERSION "${CMAKE_SYSTEM_VERSION}")

# Enable rpath support
set(CMAKE_SHARED_LIBRARY_RUNTIME_C_FLAG "-Wl,-rpath,")

set(CMAKE_SYSROOT /opt/x86_64-apple-darwin14/x86_64-apple-darwin14/sys-root)
set(CMAKE_SYSTEM_FRAMEWORK_PATH
    ${CMAKE_SYSROOT}/System/Library/Frameworks
    ${CMAKE_SYSROOT}/System/Library/PrivateFrameworks
)
set(CMAKE_INSTALL_PREFIX $ENV{prefix})

set(CMAKE_C_COMPILER   /opt/bin/x86_64-apple-darwin14-gcc)
set(CMAKE_CXX_COMPILER /opt/bin/x86_64-apple-darwin14-g++)

set(CMAKE_LINKER  /opt/bin/x86_64-apple-darwin14-ld)
set(CMAKE_OBJCOPY /opt/bin/x86_64-apple-darwin14-objcopy)

set(CMAKE_AR     /opt/x86_64-apple-darwin14/bin/x86_64-apple-darwin14-gcc-ar)
set(CMAKE_NM     /opt/x86_64-apple-darwin14/bin/x86_64-apple-darwin14-gcc-nm)
set(CMAKE_RANLIB /opt/x86_64-apple-darwin14/bin/x86_64-apple-darwin14-gcc-ranlib)

if( $ENV{CC} MATCHES ccache )
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
endif()
